<template>
  <div
    :id="accordionId"
    class="fr-collapse beneficiary-history-details-body"
  >
    <template v-if="displayDetailedHistory">
      <BeneficiaryHistoryDetailsBodyMetas :history="history" />

      <BeneficiaryHistoryDetailsBodyDocuments
        v-if="history.documents?.length"
        :documents="history.documents"
      />

      <template v-if="history.synthesis">
        <h3 class="synthesis-title">Compte rendu</h3>
        <p class="synthesis-content">{{ history.synthesis }}</p>
      </template>

      <template v-if="privateSynthesis">
        <h3 class="synthesis-title fr-icon-lock-line">Compte rendu privé</h3>
        <p class="synthesis-content">{{ privateSynthesis }}</p>
      </template>

      <ul
        class="fr-btns-group fr-btns-group--sm fr-btns-group--inline fr-btns-group--right"
      >
        <li v-if="canDelete">
          <button
            class="fr-btn fr-btn--secondary btn-delete"
            data-fr-opened="false"
            aria-controls="global-modal"
            type="button"
            @click="onDelete"
          >
            Supprimer
          </button>
        </li>
        <li v-if="canEdit">
          <NuxtLink
            :to="editLink"
            class="fr-btn fr-btn--secondary"
            target="_self"
          >
            Modifier
          </NuxtLink>
        </li>
      </ul>

      <hr class="fr-pb-3v" />
    </template>

    <BeneficiaryHistoryComments
      class=""
      :comments="comments"
      :history="history"
      @comment-added="onCommentAdded"
    />
  </div>
</template>

<script setup>
  import DeleteForm from '~/components/DeleteForm.vue'
  import { usePermissionsStore } from '~/store/permissions'
  import {
    HELP_REQUESTS_COLLECTION,
    INTERVIEWS_COLLECTION
  } from '~/utils/constants/history'
  import { Routes } from '~/utils/routing/routes'

  const { $modal, $snackbar } = useNuxtApp()
  const route = useRoute()
  const permissionsStore = usePermissionsStore()

  const props = defineProps({
    history: { type: Object, required: true },
    accordionId: { type: String, required: true }
  })

  const emit = defineEmits(['deleted'])

  const comments = ref(props.history.comments || [])

  const privateSynthesis = computed(() => {
    if (
      props.history.private_synthesis?.length &&
      props.history.private_synthesis[0].private_synthesis
    ) {
      return props.history.private_synthesis[0].private_synthesis
    }
    return ''
  })

  const editLink = computed(() => {
    const routeWithParams = props.history.isInterview
      ? Routes.BeneficiaryInterviewsEdit
      : Routes.BeneficiaryHelpRequestsEdit
    return routeWithParams(route.params.id, props.history.id)
  })

  const canEdit = computed(() =>
    permissionsStore.canEditHistoryItem(props.history)
  )

  const canDelete = computed(() =>
    permissionsStore.canDeleteHistoryItem(props.history)
  )

  const displayDetailedHistory = computed(() =>
    permissionsStore.canDisplayDetailedHistory(props.history)
  )

  function onCommentAdded(comment) {
    comments.value.push(comment)
  }

  function onDelete() {
    $modal.open(
      props.history.isInterview
        ? "Supprimer la synthèse d'entretien"
        : "Supprimer l'instruction de demande d'aide",
      DeleteForm,
      {
        itemId: props.history.id,
        collection: props.history.isInterview
          ? INTERVIEWS_COLLECTION
          : HELP_REQUESTS_COLLECTION
      },
      { deleted: onHistoryItemDeleted }
    )
  }

  function onHistoryItemDeleted() {
    emit('deleted')
    $snackbar.success("L'accompagnement a été supprimé.")
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;

  .beneficiary-history-details-body {
    --text-spacing: 0 0 1rem;

    border-radius: 0 0 0.5rem 0.5rem;

    &.fr-collapse--expanded {
      padding: 2rem 1.5rem 1rem;
    }
  }

  .synthesis-title {
    @include dsfr.text-style(md);

    margin-bottom: 0.5rem;

    &::before {
      margin-right: 0.25rem;
    }
  }

  .synthesis-content {
    white-space: pre-line;
  }

  .btn-delete {
    box-shadow: inset 0 0 0 1px var(--red-marianne-main-472);
    color: var(--red-marianne-main-472);
  }
</style>

<style>
  .beneficiary-history-details-body .information-label {
    color: var(--text-title-grey);
    font-weight: 700;
  }
</style>
